/* src/aide.c - Aide
 * Copyright (C) 2002-2004 Inter System
 *
 * contact: Progs@Inter-System.Net
 *          Cesar@Inter-System.Net
 *          kouak@kouak.org
 * site web: http://coderz.inter-system.net
 *
 * Services pour serveur IRC. Support sur IrcProgs et IrCoderZ
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * $Id: aide.c,v 1.25 2004/04/13 22:17:39 romexzf Exp $
 */

#include "main.h"
#include "cs_cmds.h"
#include "outils.h"
#include "hash.h"
#include "showcommands.h"

int syntax_cmd(aNick *nick, aHashCmd *cmd)
{
	static char helpcmd[CMDLEN + 1] = {0};

	if(!*cmd->syntax) return csntc(nick, "\2Erreur de syntaxe !");
	if(helpcmd[0] == 0) strcpy(helpcmd, RealCmd("aide"));

	csntc(nick, cmd->syntax, "Syntaxe:", cmd->name);
	csntc(nick, GetReply(nick, L_MOREHELP), cs.nick, helpcmd, cmd->name);
	return 1;
}

int aide(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	FILE *fp;
	char buf[450] = "aide/", more[16], list[450] = {0};
	int morelen = 0, cur = 0, l = 0;
	aHashCmd *cmdp;

	if(!parc) return showcommands(nick, chaninfo, parc, parv);

	if(!(cmdp = FindCommand(parv[1]))) return csntc(nick, GetReply(nick, L_NOSUCHCMD), parv[1]);

	strupr(cmdp->corename); /* as file are not renamed on name change, need to look for corename */
	sprintf(buf + 5, "%s/%s", nick->user ? nick->user->lang->langue : DefaultLang->langue, cmdp->corename);

	if(!(fp = fopen(buf, "r"))) return csntc(nick, "\2Aide non trouve, consultez un Administrateur");
	else if(parc > 1) {
		Strncpy(more, parv[2], sizeof more - 1);
		morelen = strlen(more);
		csntc(nick, GetReply(nick, L_HELP1), parv[1], more,
			AdmCmd(cmdp) ? "4ADMIN" : ChanCmd(cmdp) ? "12CHAN" : "3USER", cmdp->level);
	}
	else {
		csntc(nick, GetReply(nick, L_HELP2), parv[1],
			AdmCmd(cmdp) ? "4ADMIN" : ChanCmd(cmdp) ? "12CHAN" : "3USER", cmdp->level);
		csntc(nick, cmdp->syntax, "Syntaxe:", cmdp->name);
	}

	while(fgets(buf, sizeof buf, fp))
	{
		char *p = buf;
		if(*p == '|')
		{
			p++; /* drop the pipe */
			if(morelen)
			{
				if(!strncasecmp(p, more, morelen)) /* sous section trouve */
				{
					csntc(nick, "%s", p);
					cur = 1;
					continue;
				}
				if(cur) break;
			}
			else l = 1;
			p = strtok(p, " ");
			strcat(list, " ");
			strcat(list, p);
		}
		else if(cur || (!morelen && !l)) csntc(nick, "%s", buf);
	}

	if(morelen && !cur)
	{
		csntc(nick, "Aucune aide sur \2%s\2 pour la commande %s", more, parv[1]);
		if(*list) csntc(nick, GetReply(nick, L_OPTIONS), list);
	}
	else
	{
		if(!morelen && *list) csntc(nick, GetReply(nick, L_OPTIONS), list);
		csntc(nick, GetReply(nick, L_SHOWCMDHELP2), bot.chan);
	}
	if(cmdp->flag & CMD_DISABLE) csntc(nick, "\2\0034Note:\2\3 %s", GetReply(nick, L_CMDDISABLE));

	fclose(fp);
	return 1;
}
